
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// fading net | verblassendes netz

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// semi-transparent background | halbtransparenter hintergrund
  noStroke();
  fill( 255, 255*.2 );
  rect( 0, 0, width, height );
  //////// other display presets | weitere darstellungseinstellungen
  textSize( width/64 );
  stroke( 0, 0, 255 );
  fill( 255*.7, 255*.7, 255 );
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    //////// depict text, if desired | text darstellen, falls gewuenscht
    text( my_chars[i], my_xs[i], my_ys[i] );
    //////// making random connections ... | zufaellige verbindungen ...
    for( int j=0; j<4; j++ ) {
      int rand_id = int( random(my_chars.length) );
      //////// ... to the same character | ... zu den gleichen symbolen zeichnen
      if( my_chars[i]==my_chars[rand_id] ) {
        line( my_xs[i], my_ys[i], my_xs[rand_id], my_ys[rand_id] );
      }
    }
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
}
