
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// interpolation | interpolation

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// more variables
float[] more_xs, more_ys;

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
  //////// setup additional data | weitere daten vorbereiten
  alternativeCoords();
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// basic display modes and calculations | grundsaetzliche darstellung und berechnungen
  background( 255 );
  textAlign( CENTER, CENTER );
  textSize( width/64 );
  fill( 255*.9 );
  float r = map( mouseX, width, 0, 0, 255 );
  float b = map( mouseY, height, 0, 0, 255 );;
  stroke( r, 0, b );
  //////// sorting the character array | die zeichenliste sortieren
  my_chars = sort( my_chars );
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    //////// depict text, if desired | text darstellen, falls gewuenscht
    text( my_chars[i], my_xs[i], my_ys[i] );
    //////// making connections ... | verbindungen ...
    for( int j=i+1; j<my_chars.length; j++ ) {
      //////// ... to the same character | ... zu den gleichen symbolen zeichnen
      if( my_chars[i]==my_chars[j] ) {
        //////// mouse-interpolation between two values | maus-interpolation zwischen zwei werten
        float x0 = map( mouseX, width, 0, my_xs[i], more_xs[i] );
        float y0 = map( mouseY, height, 0, my_ys[i], more_ys[i] );
        float x1 = map( mouseX, width, 0, my_xs[j], more_xs[j] );
        float y1 = map( mouseY, height, 0, my_ys[j], more_ys[j] );
        line( x0, y0, x1, y1 );
      } else {
        break;
      }
    }
  }
}

//////// more functions
void alternativeCoords() {
  more_xs = new float[ my_size ];
  more_ys = new float[ my_size ];
  for( int i=0; i<my_chars.length; i++ ) {
    more_xs[i] = random( width );
    more_ys[i] = random( height );
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
  //////// more interaction
  if( key==' ' ) alternativeCoords();
}
