
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// bonding entities | sich bindende einheiten

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// more variables
float[] move_xs, move_ys;

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
  //////// setup additional data | weitere daten vorbereiten
  calcMove();
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// basic display modes and calculations | grundsaetzliche darstellung und berechnungen
  background( 255 );
  textAlign( CENTER, CENTER );
  textSize( width/92 );
  int subdiv = 16;
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    //////// calc numerator and text | dividend und text berechnen
    int subnum = int(my_chars[i]) % subdiv;
    String txt = int(my_chars[i]) + "%" + subdiv + "=\n" + subnum + "\n";
    //////// depict what's necessary | was notwendig ist darstellen
    fill( 255*.95 );
    text( txt, my_xs[i], my_ys[i] );
    noFill();
    stroke( 255, 0, 127 );
    circle( my_xs[i], my_ys[i], width/64 );
    //////// move bubbles around | die blaeschen bewegen
    my_xs[i] += move_xs[i];
    my_ys[i] += move_ys[i];
    if( my_xs[i]<0 || my_xs[i]>width ) move_xs[i] *= -1;
    if( my_ys[i]<0 || my_ys[i]>height ) move_ys[i] *= -1;
    //////// create connections, if close | verbindungen aufbauen, falls nahe
    for( int j=i+1; j<my_chars.length; j++ ) {
      float dis = dist( my_xs[i], my_ys[i], my_xs[j], my_ys[j] );
      if( dis<width/8 ) {
        if( subnum==int(my_chars[j])%subdiv ) {
          float col = map( dis, 0, width/8, 255, 0 );
          stroke( 255, 0, 127, col );
          line( my_xs[i], my_ys[i], my_xs[j], my_ys[j] );
        }
      }
    }
  }
}

//////// more functions
void calcMove() {
  move_xs = new float[ my_size ];
  move_ys = new float[ my_size ];
  for( int i=0; i<my_chars.length; i++ ) {
    move_xs[i] = random( -1, 1 );
    move_ys[i] = random( -1, 1 );
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
  //////// more interaction
  if( key==' ' ) calcMove();
}
